//---------------------------------------------------------------------------

#ifndef sys_splashH
#define sys_splashH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <forms.hpp>
//---------------------------------------------------------------------------

void FormRegion(HWND Handle, Graphics::TBitmap* Bitmap, TColor TransparentColor, int Range);

//---------------------------------------------------------------------------

void close_splash(AnsiString t="")
{
	static AnsiString id("");
	if(id=="")
	{
		id=t;
		return;
	}
	HANDLE handle_ = OpenMutex(MUTEX_ALL_ACCESS,TRUE,id.c_str());
	ReleaseMutex(handle_);
	CloseHandle(handle_);
};

//---------------------------------------------------------------------------

template <class T>
class splashImpl : public TThread
{
private:
	AnsiString pid_;
	T* form_;
	int sl_interval_;
	HANDLE handle_;
  bool can_close_;
	void __fastcall ShowForm(){form_->Show();form_->Refresh();}
	void __fastcall CloseForm(){can_close_=true;/*if(form_) */form_->Close();}
protected:
	void __fastcall Execute()
	{
		Synchronize(ShowForm);
		if(sl_interval_>0)
			Sleep(sl_interval_);
		while(!Application)
			Sleep(100);
		while(!Application->MainForm)
			Sleep(100);
		while(Application->MainForm->Visible==false)
			Sleep(100);
		if(sl_interval_<0)
		{
      if(sl_interval_==-1)
      {
				HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,TRUE,pid_.c_str());
				WaitForSingleObject(h,INFINITE);
      }else
	      Sleep(-sl_interval_);
		}
		Synchronize(CloseForm);
	}
public:
	__fastcall splashImpl(int sl,AnsiString p):TThread(False),sl_interval_(sl),pid_(p)
	{
  	can_close_ = false;
		form_ = new T(NULL);
    form_->OnCloseQuery = FormCloseQuery;
		handle_ = CreateMutex(NULL,TRUE,pid_.c_str());
	}
  
	__fastcall ~splashImpl()
	{
		ReleaseMutex(handle_);
		CloseHandle(handle_);
		delete form_;
	}
  
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose)
	{
		CanClose = can_close_;
	}

  void can_close()
  {
  	can_close_ = true;
  }
  
	T* get(){return form_;}
};

//---------------------------------------------------------------------------

template <class T>
class splash
{
private:
	splashImpl<T> *impl_;
	splash();
public:
	splash(int sl,AnsiString pid="sys_unknown")
	{
		impl_ = new splashImpl<T>(sl,pid+"_splash");
		close_splash(pid+"_splash");
	}
	~splash(){delete impl_;}
	T* operator()(){return impl_->get();}
  void can_close(){impl_->can_close();};
};

//---------------------------------------------------------------------------
#endif
 